﻿local VERSION = tonumber(("$Revision: 53405 $"):match("%d+"))

local CowTip = Rock:NewAddon("CowTip", "LibRockDB-1.0", "LibRockEvent-1.0", "LibRockConsole-1.0", "LibRockHook-1.0", "LibRockModuleCore-1.0", "LibRockConfig-1.0")
_G.CowTip = CowTip
local self = CowTip
CowTip.version = "2.0r" .. VERSION
CowTip.revision = VERSION
CowTip.date = ("$Date: 2007-10-28 18:53:12 -0400 (Sun, 28 Oct 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")

local _G = _G
local GameTooltip = _G.GameTooltip
local geterrorhandler = _G.geterrorhandler
local pcall = _G.pcall
local ipairs = _G.ipairs
local InCombatLockdown = _G.InCombatLockdown
local UIParent = _G.UIParent
local rawget = _G.rawget
local pairs = _G.pairs
local setmetatable = _G.setmetatable
local type = _G.type

local localeTables = {}
function CowTip:L(name, defaultTable)
	if not localeTables[name] then
		localeTables[name] = setmetatable(defaultTable or {}, {__index = function(self, key)
			self[key] = key
			return key
		end})
	end
	return localeTables[name]
end

local localization = (GetLocale() == "koKR") and {
	["Tooltip of awesomeness. Moo. It'll graze your pasture."] = "Tooltip of awesomeness. Moo. It'll graze your pasture.",
	["Waterfall-1.0 is required to access the GUI."] = "GUI 메뉴는 Waterfall-1.0 라이브러리가 필요합니다.",
	["Never"] = "없음",
	["Out of combat"] = "비전투 시",
	["Always"] = "항상",
	["Show tooltips"] = "툴팁 표시",
	["Show tooltips in specific situations only."] = "특정 상황에만 툴팁을 표시합니다.",
	["World units"] = "월드 유닛",
	["Show the tooltip for world units if..."] = "월드 유닛에 대한 툴팁 표시 시점",
	["World objects"] = "월드 객체",
	["Show the tooltip for world objects if..."] = "월드 객체에 대한 툴팁 표시 시점",
	["Unit frames"] = "유닛 프레임",
	["Show the tooltip for unit frames if..."] = "유닛 프레임에 대한 툴팁 표시 시점",
	["Non-unit frames"] = "비유닛 프레임",
	["Show the tooltip for non-unit frames if..."] = "비유닛 프레임에 대한 툴팁 표시 시점",
	["Enable"] = "사용",
	["Enable this module"] = "해당 모듈을 사용합니다.",
	["CowTip Configuration"] = "CowTip 환경설정",
	["Solo"] = "혼자",
	["Party"] = "파티",
	["Raid"] = "공격대",
	["Off"] = "끔",
	["Configuration mode"] = "환경설정 모드",
	["|cffffff00Click|r to lock/unlock unit frames."] = "유닛 프레임을 잠금/해제 하려면 |cffffff00클릭|r하세요.",
	["|cffffff00Shift-Click|r to change configuration mode."] = "환경설정 모드를 변경하려면 |cffffff00SHIFT-클릭|r하세요.",
	["|cffffff00Left-Click|r to change settings with a nice GUI configuration."] = "GUI 환경설정으로 설정을 변경하려면 |cffffff00좌-클릭|r하세요.",
	["|cffffff00Right-Click|r to change settings with a drop-down menu."] = "드롭-다운 메뉴로 설정을 변경하려면 |cffffff00우-클릭|r하세요.", 
} or (GetLocale()  == "zhTW") and {
	["Tooltip of awesomeness. Moo. It'll graze your pasture."] = "Tooltip of awesomeness. Moo. It'll graze your pasture.",
	["Never"] = "永不",
	["Out of combat"] = "戰鬥外",
	["Always"] = "總是",
	["Show tooltips"] = "顯示提示訊息",
	["Show tooltips in specific situations only."] = "只在特定的情況顯示提示訊息。",
	["World units"] = "世界單位",
	["Show the tooltip for world units if..."] = "顯示世界單位 (其他玩家，NPC...) 的提示訊息",
	["World objects"] = "世界物件",
	["Show the tooltip for world objects if..."] = "顯示世界物件 (郵箱，屍體...) 的提示訊息",
	["Unit frames"] = "單位框架",
	["Show the tooltip for unit frames if..."] = "顯示單位框架的提示訊息",
	["Non-unit frames"] = "非單位框架",
	["Show the tooltip for non-unit frames if..."] = "顯示非單位框架 (法術，物品...) 的提示訊息",
	["Only show with modifier"] = "只在按下調整鍵時顯示",
	["Only show tooltip if the specified modifier is being held down."] = "只在按下調整鍵時顯示提示訊息",
	["Enable"] = "啟用",
	["Enable this module"] = "啟用此模組",
	["No modifier"] = "無調整鍵",
	["Alt"] = "Alt",
	["Control"] = "Ctrl",
	["Shift"] = "Shift",
} or (GetLocale()  == "frFR") and {
	["Tooltip of awesomeness. Moo. It'll graze your pasture."] = "Infobulles personnalisées. Meuh. J'aime regarder les train passer.",
	["Never"] = "Jamais",
	["Out of combat"] = "Hors combat",
	["Always"] = "Toujours",
	["Show tooltips"] = "Afficher les infobulles",
	["Show tooltips in specific situations only."] = "Affiche les infobbules dans des conditions spécifiques uniquement.",
	["World units"] = "Unités du jeu",
	["Show the tooltip for world units if..."] = "Affiche les infobulles des unités du jeu si...",
	["World objects"] = "Objets du jeu",
	["Show the tooltip for world objects if..."] = "Affiche les infobulles des objets du jeu si...",
	["Unit frames"] = "Fenêtres d'unité",
	["Show the tooltip for unit frames if..."] = "Affiche les infobulles des fenêtres d'unité si...",
	["Non-unit frames"] = "Fenêtres de non-unité",
	["Show the tooltip for non-unit frames if..."] = "Affiche les infobulles des fenêtres de non-unité si...",
	["Only show with modifier"] = "Afficher uniquement avec modificateur",
	["Only show tooltip if the specified modifier is being held down."] = "Affiche les infobulles uniquement si le modificateur spécifié est maintenu enfoncé.",
	["Enable"] = "Activer",
	["Enable this module"] = "Active ce module.",
	["No modifier"] = "Pas de modificateur",
	["Alt"] = "Alt",
	["Control"] = "Ctrl",
	["Shift"] = "Shift",
} or {}

local L = CowTip:L("CowTip", localization)

CowTip:SetDatabase("CowTipDB")
CowTip:SetDatabaseDefaults('profile', {
	unitShow = "always",
	unitFrameShow = "always",
	otherFrameShow = "always",
	objectShow = "always",
	modifier = "NONE",
})

local leftGameTooltipStrings = {}
local rightGameTooltipStrings = {}
CowTip.leftGameTooltipStrings = leftGameTooltipStrings
CowTip.rightGameTooltipStrings = rightGameTooltipStrings

function CowTip:OnInitialize()
	self:SetConfigTable(self.options)
	self:SetConfigSlashCommand('/CowTip', '/Cow')
	
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE")
	for i = 1, 50 do
		GameTooltip:AddDoubleLine(' ', ' ')
		leftGameTooltipStrings[i] = _G["GameTooltipTextLeft" .. i]
		rightGameTooltipStrings[i] = _G["GameTooltipTextRight" .. i]
	end
	GameTooltip:Show()
	GameTooltip:Hide()
end

function CowTip:OnEnable()
	self:AddScriptHook(GameTooltip, "OnShow", "GameTooltip_OnShow")
	self:AddScriptHook(GameTooltip, "OnHide", "GameTooltip_OnHide")
	self:AddScriptHook(GameTooltip, "OnTooltipSetUnit", "GameTooltip_OnTooltipSetUnit")
	self:AddScriptHook(GameTooltip, "OnTooltipSetItem", "GameTooltip_OnTooltipSetItem")
	self:AddScriptHook(GameTooltip, "OnTooltipSetSpell", "GameTooltip_OnTooltipSetSpell")
	
	self:AddHook(GameTooltip, "FadeOut", "GameTooltip_FadeOut")
	
	self:AddEventListener("MODIFIER_STATE_CHANGED")
end

function CowTip:OnDisable()
	self:GameTooltip_OnHide(GameTooltip)
end

local function OnTooltipMethod(self, method)
	for i = 1, 3 do
		local methodName
		if i == 1 then
		 	methodName = "PreTooltip" .. method
		elseif i == 2 then
			methodName = "OnTooltip" .. method
		else
			methodName = "PostTooltip" .. method
		end
		self:CallMethodOnAllModules(true, methodName)
	end
end

local doneOnTooltipMethod = false

local forgetNextOnTooltipMethod = false
function CowTip:GameTooltip_OnTooltipSetUnit(this, ...)
	doneOnTooltipMethod = true
	self.hooks[this].OnTooltipSetUnit(this, ...)
	
	if forgetNextOnTooltipMethod then
		forgetNextOnTooltipMethod = false
	else
		OnTooltipMethod(self, "SetUnit")
	end
end

function CowTip:GameTooltip_OnTooltipSetItem(this, ...)
	forgetNextOnTooltipMethod = true
	self.hooks[this].OnTooltipSetItem(this, ...)
	
	if forgetNextOnTooltipMethod then
		forgetNextOnTooltipMethod = false
	else
		OnTooltipMethod(self, "SetItem")
	end
end

function CowTip:GameTooltip_OnTooltipSetSpell(this, ...)
	doneOnTooltipMethod = true
	self.hooks[this].OnTooltipSetSpell(this, ...)
	
	if forgetNextOnTooltipMethod then
		forgetNextOnTooltipMethod = false
	else
		OnTooltipMethod(self, "SetSpell")
	end
end

function CowTip:MODIFIER_STATE_CHANGED(ns, event, modifier, down)
	local mod = self.db.profile.modifier
	if mod ~= modifier then
		return
	end
	local frame = GetMouseFocus()
	if frame == WorldFrame or frame == UIParent then
		if not UnitExists("mouseover") then
			GameTooltip:Hide()
			return
		end
		GameTooltip:Hide()
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
		GameTooltip:SetUnit("mouseover")
		GameTooltip:Show()
	else
		local OnLeave, OnEnter = frame:GetScript("OnLeave"), frame:GetScript("OnEnter")
		if OnLeave then
			_G.this = frame
			OnLeave(frame)
			_G.this = nil
		end
		if OnEnter then
			_G.this = frame
			OnEnter(frame)
			_G.this = nil
		end
	end
end

function CowTip:GameTooltip_OnShow(this, ...)
	if not doneOnTooltipMethod then
		if this:GetUnit() then
			OnTooltipMethod(self, "SetUnit")
			forgetNextOnTooltipMethod = true
		elseif this:GetItem() then
			OnTooltipMethod(self, "SetItem")
			forgetNextOnTooltipMethod = true
		elseif this:GetSpell() then
			OnTooltipMethod(self, "SetSpell")
			forgetNextOnTooltipMethod = true
		end
	end
	local show
	if this:IsOwned(UIParent) then
		if this:GetUnit() then
			-- world unit
			show = self.db.profile.unitShow
		else
			-- world object
			show = self.db.profile.objectShow
		end
	else
		if this:GetUnit() then
			-- unit frame
			show = self.db.profile.unitFrameShow
		else
			-- non-unit frame
			show = self.db.profile.otherFrameShow
		end
	end
	
	local modifier = self.db.profile.modifier
	if modifier == "ALT" then
		if not IsAltKeyDown() then
			this:Hide()
			return
		end
	elseif modifier == "SHIFT" then
		if not IsShiftKeyDown() then
			this:Hide()
			return
		end
	elseif modifier == "CTRL" then
		if not IsControlKeyDown() then
			this:Hide()
			return
		end
	end
	
	if show == "noncombat" then
		if InCombatLockdown() then
			this:Hide()
			return
		end
	elseif show == "never" then
		this:Hide()
		return
	end
	self.hooks[this].OnShow(this, ...)
	
	self:CallMethodOnAllModules(true, "OnTooltipShow")
end

function CowTip:GameTooltip_FadeOut(this, ...)
	self.hooks[this].FadeOut(this, ...)
end

function CowTip:GameTooltip_OnHide(this, ...)
	doneOnTooltipMethod = false
	forgetNextOnTooltipMethod = false
	
	self:CallMethodOnAllModules(true, "OnTooltipHide")
	
	if self.hooks[this] and self.hooks[this].OnHide then
		self.hooks[this].OnHide(this, ...)
	end
end

local showWhenChoices = {
	never = L["Never"],
	notcombat = L["Out of combat"],
	always = L["Always"],
}

local function getShowTooltip(key)
	return CowTip.db.profile[key]
end

local function setShowTooltip(key, value)
	CowTip.db.profile[key] = value
end

CowTip.options = {
	type = 'group',
	name = "CowTip",
	desc = L["Tooltip of awesomeness. Moo. It'll graze your pasture."],
	icon = [[Interface\AddOns\CowTip\icon]],
	args = {
		showTooltips = {
			type = 'group',
			name = L["Show tooltips"],
			desc = L["Show tooltips in specific situations only."],
			args = {
				unitShow = {
					name = L["World units"],
					desc = L["Show the tooltip for world units if..."],
					type = 'choice',
					choices = showWhenChoices,
					get = getShowTooltip,
					set = setShowTooltip,
					passValue = 'unitShow',
				},
				objectShow = {
					name = L["World objects"],
					desc = L["Show the tooltip for world objects if..."],
					type = 'choice',
					choices = showWhenChoices,
					get = getShowTooltip,
					set = setShowTooltip,
					passValue = 'objectShow',
				},
				unitFrameShow = {
					name = L["Unit frames"],
					desc = L["Show the tooltip for unit frames if..."],
					type = 'choice',
					choices = showWhenChoices,
					get = getShowTooltip,
					set = setShowTooltip,
					passValue = 'unitFrameShow',
				},
				otherFrameShow = {
					name = L["Non-unit frames"],
					desc = L["Show the tooltip for non-unit frames if..."],
					type = 'choice',
					choices = showWhenChoices,
					get = getShowTooltip,
					set = setShowTooltip,
					passValue = 'otherFrameShow',
				},
				showByModifier = {
					name = L["Only show with modifier"],
					desc = L["Only show tooltip if the specified modifier is being held down."],
					type = 'choice',
					choices = {
						NONE = L["No modifier"],
						ALT = L["Alt"],
						CTRL = L["Control"],
						SHIFT = L["Shift"],
					},
					get = getShowTooltip,
					set = setShowTooltip,
					passValue = 'modifier',
				},
			}
		},
	}
}

function CowTip.modulePrototype:RegisterCowTipOption(data)
	local args = CowTip.options.args
	local name = self.name
	if args[name] then
		local i = 1
		while args[name .. i] do
			i = i + 1
		end
		name = name .. i
	end
	args[name] = data
	if not data.handler then
		data.handler = self
	end
	if data.args then
		data.args.active = {
			type = 'boolean',
			name = L["Enable"],
			desc = L["Enable this module"],
			get = "IsModuleActive",
			set = "ToggleModuleActive",
			handler = CowTip,
			passValue = self,
			order = 1,
		}
	end
end
